#include "squidwall.h"

int check_acl(int type)
{
	static time_t mtime_hosts, mtime_users;
	static array array_hosts, array_users;
	struct squidwall_acl *acl;
	array *a;
	time_t *t;
	char *dir;
	int i;

	switch (type) {
	case TYPE_USER:
		dir=users_dir;
		t=&mtime_users;
		a=&array_users;
		break;
	default:
		dir=hosts_dir;
		t=&mtime_hosts;
		a=&array_hosts;
		break;
	}

	if (scan_directory(a, dir, t) == -1)
		return FLAGS_DEFAULT;

	for (i=0; i<array_length(a, sizeof(struct squidwall_acl)); i++) {
		//char buf[FMT_ULONG];
		acl = array_get(a, sizeof(struct squidwall_acl), i);

		//buf[fmt_ulong0(buf, i, 3)]=0; logs(buf);logflush();
		//logs(" / ");
		//buf[fmt_ulong0(buf, array_length(a, sizeof(struct squidwall_acl)), 3)]=0; logs(buf);logflush();
		//logs("\n");logflush();

		if (type == TYPE_USER) {
			if (case_equals(acl->name.s, user.s))
				return acl->flags;
		} else {
			if (case_equals(acl->name.s, host.s))
				return acl->flags;
			if (case_equals(acl->name.s, ip.s))
				return acl->flags;
		}
	}

	return FLAGS_DEFAULT;
}
