#ifndef SW_PRAMS_H
#define SW_PRAMS_H

/*
 * all these values can be overridden by environment variables!
 */

/* this logfile will show you the denied users/hosts/pages */
#define LOG_FILE   "/var/log/squid/squidwall.log"

/* this is the max filesize in bytes, which will be checked with clamav */
#define MAX_SIZE   300000

#define USERS_DIR "/etc/squidwall/users"
#define HOSTS_DIR "/etc/squidwall/hosts"

/* ip:port of your squid cache
 *
 * warning: this cache should not redirect to the redirector :)
 */
#define PROXY      "127.0.0.1:3128"

/* ip:port of clamd in TCP/IP mode */
#define CLAMD      "127.0.0.1:3310"

/* if a virus is found, the user will be redirected to this page */
#define REDIR_VIRUSFOUND "http://www.example.org/?network=x&reason=virus&"

/* user is forbidden */
#define REDIR_BADUSER    "http://www.example.org/?network=x&reason=user&"

/* host/ip is forbidden */
#define REDIR_BADHOST    "http://www.example.org/?network=x&reason=host&"

/* this url is allways reachable! */
#define REDIR_SAFESITE   "http://www.example.org/img/"

#endif
