#include "squidwall.h"

stralloc encoded_ip;
stralloc encoded_url;
stralloc encoded_host;
stralloc encoded_user;
stralloc encoded_virus;
stralloc encoded_method;
stralloc encoded_version;
stralloc encoded_clamd;

/* from check_clamd.c */
extern stralloc virus;
extern stralloc clamav;

void redir_site(int type)
{
	char *site=0;

	/* free the old ones */
	stralloc_init(&encoded_ip);
	stralloc_init(&encoded_url);
	stralloc_init(&encoded_host);
	stralloc_init(&encoded_user);
	stralloc_init(&encoded_method);
	stralloc_init(&encoded_version);

	/* change the url for squid */
	if (!fmt_to_sa(fmt_urlencoded, &encoded_ip, ip.s, ip.len)) die_nomem();
	if (!fmt_to_sa(fmt_urlencoded, &encoded_url, url.s, url.len)) die_nomem();
	if (!fmt_to_sa(fmt_urlencoded, &encoded_host, host.s, host.len)) die_nomem();
	if (!fmt_to_sa(fmt_urlencoded, &encoded_user, user.s, user.len)) die_nomem();
	if (!fmt_to_sa(fmt_urlencoded, &encoded_method, method.s, method.len)) die_nomem();
	if (!fmt_to_sa(fmt_urlencoded, &encoded_version, VERSION, sizeof(VERSION)-1)) die_nomem();

#if 0
	/* fmt_to_sa doesn't terminate strings */
	encoded_ip.s[encoded_ip.len]=0;
	encoded_url.s[encoded_url.len]=0;
	encoded_host.s[encoded_host.len]=0;
	encoded_user.s[encoded_user.len]=0;
	encoded_method.s[encoded_method.len]=0;
	encoded_version.s[encoded_version.len]=0;
#endif

	switch (type) {
	case TYPE_USER:
		site=redir_baduser;
		break;
	case TYPE_HOST:
		site=redir_badhost;
		break;
	case TYPE_CLAMD:
		site=redir_virusfound;
		stralloc_init(&encoded_clamd);
		stralloc_init(&encoded_virus);
		if (!fmt_to_sa(fmt_urlencoded, &encoded_virus, virus.s, virus.len)) die_nomem();
		if (!fmt_to_sa(fmt_urlencoded, &encoded_clamd, clamav.s, clamav.len)) die_nomem();
//		encoded_virus.s[encoded_virus.len]=0;
//		encoded_clamd.s[encoded_clamd.len]=0;
		break;
	}

	/* [www.example.org/?network=...&]clamd=...&ip=...&... */
	stralloc_copys(&redirsite, site);
	if (type == TYPE_CLAMD) {
		stralloc_cats(&redirsite, "clamd=");
		stralloc_cat(&redirsite, &encoded_clamd);
		stralloc_free(&encoded_clamd);
		stralloc_cats(&redirsite, "&virus=");
		stralloc_cat(&redirsite, &encoded_virus);
		stralloc_cats(&redirsite, "&");
		stralloc_free(&encoded_virus);
	}
	stralloc_cats(&redirsite, "version=");
	stralloc_cat(&redirsite, &encoded_version);
	stralloc_cats(&redirsite, "&ip=");
	stralloc_cat(&redirsite, &encoded_ip);
	stralloc_cats(&redirsite, "&url=");
	stralloc_cat(&redirsite, &encoded_url);
	stralloc_cats(&redirsite, "&host=");
	stralloc_cat(&redirsite, &encoded_host);
	stralloc_cats(&redirsite, "&user=");
	stralloc_cat(&redirsite, &encoded_user);
	stralloc_cats(&redirsite, "&method=");
	stralloc_cat(&redirsite, &encoded_method);
	stralloc_cats(&redirsite, " ");
	stralloc_cat(&redirsite, &encoded_ip);
	stralloc_cats(&redirsite, "/");
	stralloc_cat(&redirsite, &encoded_host);
	stralloc_cats(&redirsite, " ");
	stralloc_cat(&redirsite, &encoded_user);
	stralloc_cats(&redirsite, " ");
	stralloc_cat(&redirsite, &encoded_method);

	stralloc_free(&encoded_version);
	stralloc_free(&encoded_ip);
	stralloc_free(&encoded_url);
	stralloc_free(&encoded_host);
	stralloc_free(&encoded_user);
	stralloc_free(&encoded_method);

	return;
}
